var outputFile = 'jobs-local',
  RssBraider = require('rss-braider'),
  fs = require('fs'),
  ejs = require('ejs'),
  read = require('fs').readFileSync,
  join = require('path').join,
  str = read(join(__dirname, '/templates/rss.ejs'), 'utf8'),
  feeds = {};

// Pull feeds from config files:
//      feeds.simple_test_feed = require("./config/feed").feed;
// Or define in-line
feeds.simple_test_feed = {
  'feed_name': 'feed',
  'default_count': 1,
  'no_cdata_fields': [], // Don't wrap these fields in CDATA tags
  'plugins': [
    'filter_show',
    'filter_location',
    'filter_reject',
    'filter_md_jobs',
    'filter_last_week'
  ],
  'meta': {
    'title': 'Jobs',
    'description': 'Combined Jobs Feed',
    'site_url': 'http://pipes.silvrtree.co.uk/jobs-local.xml'
  },
  'sources': [{
    'count': 100,
    'feed_url': 'http://45.33.114.116:8080/https%3A%2F%2Fwww.jobserve.com%2FMySearch%2FBAEBF3BDF82B8FEF.rss'
  }]
};

var braider_options = {
  'feeds': feeds,
  'indent': '    ',
  'date_sort_order': 'desc', // Newest first
  'log_level': 'warn',
  'dedupe_fields': ['link', 'guid'],
  'plugins_directories': [`${__dirname }/plugins/`]
};
var rss_braider = RssBraider.createClient(braider_options);

// Override logging level (debug, info, warn, err, off)
rss_braider.logger.level('error');

rss_braider.processFeed('simple_test_feed', 'json', function (err, data) {
  if (err)
    return console.log(err);

  var j = JSON.parse(data);
  var ejsOutput = ejs.compile(str)(j);

  fs.writeFile(`${__dirname }/dist/${ outputFile }.html`, ejsOutput, function (err) {
    if (err)
      return console.log(err);

    console.log('The file was saved!');
  });

  fs.writeFile(`${__dirname }/dist/${ outputFile }.json`, data, function (err) {
    if (err) {
      logger.error(err);

      return console.log(err);
    }

    console.log('The file was saved!');
  });
});

rss_braider.processFeed('simple_test_feed', 'rss', function (err, data) {
  if (err)
    return console.log(err);

  fs.writeFile(`${__dirname }/dist/${ outputFile }.xml`, data, function (err) {
    if (err)
      return console.log(err);

    console.log('The file was saved!');
  });
});
